commit 34608a771216b40307bcbee767605a328265a940
Author: Iain Sandoe <iain@sandoe.co.uk>
Date:   Wed Jan 18 19:58:33 2023 +0000

    Darwin, fixincludes: Handle MacOS13 SDK Apple-specific deprecations [PR107568].
    
    The SDK for MacOS13 includes Apple-specific deprecations of some functions that
    are not deprecated in Posix, C or C++ and widely used in GCC.
    
    The fix makes the deprecation conditional on __APPLE_LOCAL_DEPRECATIONS so that
    end users may still observe them but they are hidden from normal compilations.
    
    Signed-off-by: Iain Sandoe <iain@sandoe.co.uk>
    
            PR target/107568
    
    fixincludes/ChangeLog:
    
            * fixincl.x: Regenerate.
            * inclhack.def: Add a fix for MacOS13 SDK function deprecations
            in stdio.h.
            * tests/base/stdio.h (__deprecated_msg): New test.
    
    (cherry picked from commit 442d2bdc1d2a98aba0b18aeaa3e87fa946ac8031)

diff --git a/fixincludes/inclhack.def b/fixincludes/inclhack.def
index f58e7771e1c..c6f3a44b0bd 100644
--- a/fixincludes/inclhack.def
+++ b/fixincludes/inclhack.def
@@ -1229,6 +1229,18 @@ fix = {
     test_text = '#define  vfscanf	__svfscanf';
 };
 
+fix = {
+    hackname  = apple_local_stdio_fn_deprecation;
+    mach      = "*-*-*darwin2*";
+    files     = stdio.h;
+    select    = "__deprecated_msg([^\n]*)$";
+    c_fix     = format;
+    c_fix_arg = "#if defined(__APPLE_LOCAL_DEPRECATIONS)\n"
+                "%0\n"
+                "#endif";
+    test_text = '__deprecated_msg("This function is provided for compat...")';
+};
+
 /*
  *  Fix various macros used to define ioctl numbers.
  *  The traditional syntax was:
diff --git a/fixincludes/tests/base/stdio.h b/fixincludes/tests/base/stdio.h
index 491c75da6e5..38381bacb2d 100644
--- a/fixincludes/tests/base/stdio.h
+++ b/fixincludes/tests/base/stdio.h
@@ -41,6 +41,13 @@ int vfscanf(FILE *, const char *, __builtin_va_list) __asm__ (_BSD_STRING(__USER
 #endif  /* BSD_STDIO_ATTRS_CONFLICT_CHECK */
 
 
+#if defined( APPLE_LOCAL_STDIO_FN_DEPRECATION_CHECK )
+#if defined(__APPLE_LOCAL_DEPRECATIONS)
+__deprecated_msg("This function is provided for compat...")
+#endif
+#endif  /* APPLE_LOCAL_STDIO_FN_DEPRECATION_CHECK */
+
+
 #if defined( HPUX10_STDIO_DECLARATIONS_CHECK )
 #  define _iob __iob
 

